/**********************************************************************
 *
 * Filename:    crc.h
 * 
 * Description: A header file describing the various CRC standards.
 *
 * Notes:       
 *
 * 
 * Copyright (c) 2000 by Michael Barr.  This software is placed into
 * the public domain and may be used for any purpose.  However, this
 * notice must not be changed or removed and no warranty is either
 * expressed or implied by its publication or distribution.
 *
 *
 * Modfied Feb 2017
 * Copyright (c) 2017 Motas Electronics Limited
 **********************************************************************/

#include "qglobal.h"
#include "stdint.h"
#ifdef __cplusplus
extern "C" {
#endif




#ifndef _crc_h
#define _crc_h


#define FALSE	0
#define TRUE	!FALSE

/*
 * Select the CRC standard from the list that follows.
 */
#define CRC32_STMF4


#if defined(CRC32_STMF4)

typedef quint32  crc;

#define CRC_NAME			"CRC-32-STMF4"
#define POLYNOMIAL			0x04C11DB7
#define INITIAL_REMAINDER	0xFFFFFFFF
#define FINAL_XOR_VALUE		0x00000000
#define REFLECT_DATA		FALSE
#define REFLECT_REMAINDER	FALSE
#define CHECK_VALUE			0x00

#else

#error

#endif


void  crcInit(void);

crc   crcFast(const quint8 message[], int nBytes);
crc   crcFastSTMF4(const quint8 message[], int32_t nBytes);


#endif /* _crc_h */
#ifdef __cplusplus
}
#endif
